#ifndef CHOONVDELIVER__H__
#define CHOONVDELIVER__H__

#define CATCH_NE_ZERO(exp, fn, debug) \
	if ((exp) != 0) { \
		if (debug) { \
			errmsgf("{function='}s{' line='}d{' (}s{ != 0)\n}", \
				__FUNCTION__, __LINE__, #exp); \
			if (errno) { \
				errmsgf("{\nerrno=}d{ errmsg=}s{", \
					errno, strerror(errno)); \
			} \
		} \
		if (#fn) { \
			(fn); \
		} \
	}

#define CATCH_NE_ONE(exp, fn, debug) \
	if ((exp) != 1) { \
		if (debug) { \
			errmsgf("{function='}s{' line='}d{' (}s{ != 1)\n}", \
				__FUNCTION__, __LINE__, #exp); \
			if (errno) { \
				errmsgf("{\nerrno=}d{ errmsg=}s{", \
					errno, strerror(errno)); \
			} \
		} \
		if (#fn) { \
			(fn); \
		} \
	}

#define CATCH_NULL(exp, fn, debug) \
	if ((exp) == NULL) { \
		if (debug) { \
			errmsgf("{function='}s{' line='}d{' (}s{ == NULL)\n}", \
				__FUNCTION__, __LINE__, #exp); \
			if (errno) { \
				errmsgf("{\nerrno=}d{ errmsg=}s{", \
					errno, strerror(errno)); \
			} \
		} \
		if (#fn) { \
			(fn); \
		} \
	}

#include "outerrmsg.h"
#include "str_random.h"
#include "is_file.h"
#include "is_dir.h"
#include "is_maildir.h"
#include "is_seekable.h"
#include "make_seekable.h"
#include "mkmaildir.h"
#include "maildirformatname.h"

#endif

#ifndef STDIN_FILENO
#define STDIN_FILENO 0
#endif
#ifndef STDOUT_FILENO
#define STDOUT_FILENO 1
#endif
#ifndef STDERR_FILENO
#define STDERR_FILENO 2
#endif
#ifndef LF
#define LF ((char)10)
#endif

